// 
{*******************************************************}
{                                                       }
{                E L E K S   R E P O R T S              }        
{                                                       }
{        Copyright (C) 1998, 1999 Eleks Software        }
{               Created by Andriy Gerasika              }
{                  All rights reserved                  }
{                                                       }
{                 http://eleks.txnet.com                }
{                    eleks@fnmail.com                   }
{                                                       }
{*******************************************************}


// $Archive: /H/Gerix/Projects/elReports/elReportsDemoUnit.pas $ $Author: Gerix $ $Date: 1.09.99 15:30 $ $Revision: 14 $ $Workfile: elReportsDemoUnit.pas $

unit elReportsDemoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ActiveX,
  StdCtrls, Db, DBTables, Buttons, Grids, DBGrids,
  elReports_TLB, elReportsEUI_TLB, elReportsBDE_TLB, elReportsUtils, ComObj, ComServ,
  DBCtrls, ExtCtrls, ComCtrls, elReportsBDEImpl;

type
  TForm1 = class(TForm
  )
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    FishSource: TDataSource;
    FishTable: TTable;
    FishTableCategory: TStringField;
    FishTableSpeciesName: TStringField;
    FishTableLengthcm: TFloatField;
    FishTableLength_In: TFloatField;
    FishTableCommon_Name: TStringField;
    FishTableNotes: TMemoField;
    FishTableGraphic: TGraphicField;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel3: TPanel;
    DBMemo1: TDBMemo;
    Panel7: TPanel;
    Panel1: TPanel;
    DBImage1: TDBImage;
    Panel8: TPanel;
    DBLabel1: TDBText;
    Panel4: TPanel;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    FishReportBtn: TButton;
    Customer: TTable;
    Order: TTable;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    Panel9: TPanel;
    DBGrid2: TDBGrid;
    Panel10: TPanel;
    DBGrid3: TDBGrid;
    Panel11: TPanel;
    CustOrdReportBtn: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Example1: TTabSheet;
    Example2: TTabSheet;
    Label12: TLabel;
    Edit1: TEdit;
    Label13: TLabel;
    Edit2: TEdit;
    Button4: TButton;
    Label14: TLabel;
    Memo2: TMemo;
    Label15: TLabel;
    Memo3: TMemo;
    Label16: TLabel;
    Edit3: TEdit;
    Label17: TLabel;
    Memo4: TMemo;
    Label18: TLabel;
    Edit4: TEdit;
    Label19: TLabel;
    Edit5: TEdit;
    Label20: TLabel;
    Memo5: TMemo;
    Button5: TButton;
    Label21: TLabel;
    Memo6: TMemo;
    Label22: TLabel;
    Label23: TLabel;
    Example3: TTabSheet;
    Label24: TLabel;
    Memo7: TMemo;
    Label25: TLabel;
    Memo8: TMemo;
    Button6: TButton;
    Label26: TLabel;
    Label27: TLabel;
    Edit6: TEdit;
    Label28: TLabel;
    Edit7: TEdit;
    Example4: TTabSheet;
    Label4: TLabel;
    Edit8: TEdit;
    Label5: TLabel;
    Memo9: TMemo;
    Label6: TLabel;
    Edit9: TEdit;
    Label8: TLabel;
    Edit10: TEdit;
    Label9: TLabel;
    Button3: TButton;
    Label3: TLabel;
    Edit11: TEdit;
    Label10: TLabel;
    Memo10: TMemo;
    Label7: TLabel;
    Label11: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    procedure FishReportBtnClick(Sender: TObject);
    procedure CustOrdReportBtnClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  protected
  public
    { Public declarations }
    procedure GenerateReport(ReportName: String);
  end;

  TelReportFormCalculatedFieldCallback = class(TAutoIntfObject
  , IelReportCalculatedFieldCallback
  )
  private
    Form: TForm;
  protected
  public
    procedure Generate(const Writer: IelReportWriter; const Value: WideString); safecall;
  end;

var
  Form1: TForm1;

implementation

uses
  Consts;

{$R *.DFM}

var
  WordBasic: OleVariant;

procedure OpenFileInWord(const FileName: String);
var
  _: String;
begin
  if MessageDlg(Format('Do you want file %s to be opened in Word ?',
    [FileName]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    if VarIsEmpty(WordBasic) then
      WordBasic := CreateOleObject('Word.Basic');
    _ := ExpandFileName(FileName);
    WordBasic.FileOpen(_);
    WordBasic.AppShow;
  end;
end;

procedure TForm1.GenerateReport(ReportName: String);
var
  r: IelReport;
  cb: IelReportBDECalculatedFieldCallback;
begin
  r := CoelRtfReport.Create;
  cb := TelReportBDECalculatedFieldCallback.Create(elReportsEUILibrary, Iid_IelReportCalculatedFieldCallback);
  cb.DataSetOwner := Integer(Self);
  AddCalculatedField(r.Entities, cb, '$$', '$$');
  SetCurrentDir(ExtractFilePath(ParamStr(0)));
  r.GenerateFile('..\projects\elReports\template\' + ReportName + '.rtf',
                 '..\projects\elReports\document\' + ReportName + '.rtf');
  OpenFileInWord(ExpandFileName('..\projects\elReports\document\' + ReportName + '.rtf'));
end;

procedure TForm1.FishReportBtnClick(Sender: TObject);
begin
  FishTable.Active := False;
  FishTable.Active := True;
  GenerateReport('Fish');
end;

procedure TForm1.CustOrdReportBtnClick(Sender: TObject);
begin
  Order.Active := False;
  Customer.Active := False;
  Customer.Active := True;
  Order.Active := True;
  GenerateReport('Cust')
end;

type
  _TControl_ = class(TControl)
  public
    property Text;
  end;
  
procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePage = TabSheet2 then
    FishTable.Active := True
  else if PageControl1.ActivePage = TabSheet3 then begin
    Customer.Active := True;
    Order.Active := True;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  _: IelReport;
  ws1, ws2: WideString;
begin
  _ := CoelTextReport.Create;
  AddField(_.Entities, Edit1.Text).Values.Add(Edit2.Text);
  ws1 := Memo2.Lines.Text;
  _.GenerateString(ws1, ws2);
  Memo3.Lines.Text := ws2;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  _: IelReport;
  ws1, ws2: WideString;
  i: Integer;
begin
  _ := CoelTextReport.Create;
  with AddField(_.Entities, Edit3.Text) do begin
    RepeatedValues := True;
    for i := 0 to Memo4.Lines.Count - 1 do
      Values.Add(Memo4.Lines[i]);
  end;
  AddBeginRepeater(_.Entities, Edit4.Text);
  AddEndRepeater(_.Entities, Edit5.Text);
  ws1 := Memo5.Lines.Text;
  _.GenerateString(ws1, ws2);
  Memo6.Lines.Text := ws2;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  _: IelReport;
  ws1, ws2: WideString;
  cfc: TelReportFormCalculatedFieldCallback;
  unk: IUnknown;
begin
  _ := CoelTextReport.Create;
  cfc := TelReportFormCalculatedFieldCallback.Create(elReportsEUILibrary, Iid_IelReportCalculatedFieldCallback);
  cfc.Form := Self;
  AddCalculatedField(_.Entities, cfc, Edit6.Text, Edit7.Text);
  ws1 := Memo7.Lines.Text;
  _.GenerateString(ws1, ws2);
  Memo8.Lines.Text := ws2;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  _: IelReport;
  i: Integer;
  ReportName: String;
begin
  _ := CoelRtfReport.Create;
  with AddField(_.Entities, Edit8.Text) do begin
    RepeatedValues := True;
    for i := 0 to Memo9.Lines.Count - 1 do
      Values.Add(Memo9.Lines[i]);
  end;
  with AddField(_.Entities, Edit11.Text) do begin
    RepeatedValues := True;
    for i := 0 to Memo10.Lines.Count - 1 do
      Values.Add(Memo10.Lines[i]);
  end;
  AddBeginRepeater(_.Entities, Edit9.Text);
  AddEndRepeater(_.Entities, Edit10.Text);

  ReportName := 'marry';
  _.GenerateFile('..\projects\elReports\template\' + ReportName + '.rtf',
                 '..\projects\elReports\document\' + ReportName + '.rtf');
  OpenFileInWord(ExpandFileName('..\projects\elReports\document\' + ReportName + '.rtf'));
end;

procedure TelReportFormCalculatedFieldCallback.Generate(const Writer: IelReportWriter; const Value: WideString);
var
  C: TComponent;
begin
  C := Form.FindComponent(Value);
  if C is TControl then
    Writer.WriteString(_TControl_(C).Text);
end;

end.


